package org.enhydra.barracuda.contrib.dbroggisch.display.filters;


/**
 * The interface Filter is used in conjunction with the HashMapModel
 * to create lightweight models which are used to render data
 * inito HTML-pages. 
 *
 * @author <a href="mailto:deets@web.de">Diez Roggisch</a>
 * @version 1.0
 */
public interface Filter {
		
	/**
	 * 
	 *
	 * @param obj The object to be filtered.
	 * @return the filtered object.
		 */
	public Object filter(Object obj, FilterContext context)
		throws FilterException;

	/** Configure the the Filter with the XML Chunk.
	 *  @param obj The XML object created by ZEUS
	 *  @return The configured Filter - that can be different!
	 */
	public Filter configure(Object obj)
		throws FilterException;
	
}
