package org.enhydra.barracuda.contrib.dbroggisch.examples;


import java.util.*;
import javax.servlet.http.*;
import org.enhydra.barracuda.core.comp.*;
import org.enhydra.barracuda.core.forms.*;
import org.enhydra.barracuda.core.event.*;
import org.enhydra.barracuda.core.util.dom.DefaultDOMWriter;
import org.enhydra.barracuda.core.util.dom.DOMWriter;

import org.enhydra.barracuda.contrib.dbroggisch.examples.events.*;
import org.enhydra.barracuda.contrib.dbroggisch.examples.forms.*;
import org.enhydra.barracuda.contrib.dbroggisch.examples.xmlc.*;
import org.enhydra.barracuda.contrib.dbroggisch.repopulation.*;
import org.enhydra.barracuda.contrib.dbroggisch.page.RenderPageHandler;
import org.enhydra.barracuda.contrib.dbroggisch.display.*;
import org.apache.log4j.Logger;

import org.enhydra.barracuda.core.event.ClientSideRedirectException;

import java.io.*;
import java.util.*;
import org.enhydra.barracuda.core.event.helper.EventConnectorFactory;
import org.enhydra.barracuda.core.event.helper.EventForwardingFactory;

import org.enhydra.barracuda.core.helper.servlet.HttpServletRequestWrapper;

import org.enhydra.xml.xmlc.XMLCStdFactory;



public class DBRApplicationGateway extends ApplicationGateway {
    protected static org.apache.log4j.Logger logger = org.apache.log4j.Logger.getLogger(DBRApplicationGateway.class.getName());

	public static boolean WRAPPER_INSTALLED = false;

	public void initializeLocal() {
		WRAPPER_INSTALLED = installWrapper();
		specifyEventGateways(new RenderPageHandler.RenderPageEventGW());

	}


	public DispatcherFactory getDispatcherFactory() {
		return new RenderPageHandler.PageEventDispatcherFactory();
	}



	private  boolean installWrapper() {
		String destDir = null;
		File tempDir = (File)getServletConfig().getServletContext().getAttribute("javax.servlet.context.tempdir");
		// Only if we have write permission to that directory we install the wrapper.
		if(tempDir.canWrite()) {
			REQUEST_WRAPPER = new SampleRequestWrapper(tempDir.getAbsolutePath());
			return true;
		}
		return false;
	}

	public static class SampleRequestWrapper implements RequestWrapper {
		String _destDir;
		public SampleRequestWrapper(String destDir) {
			_destDir = destDir;
		}

		public org.enhydra.barracuda.core.helper.servlet.HttpServletRequestWrapper 
			wrap(javax.servlet.http.HttpServletRequest req) 
			
		{
			// If the request isn't multipart/mime, we'll get a IOException. Then we 
			// simply pass the request directly to the HttpServletRequestWrapperHttpServletRequestWrapper
			try {
				return new HttpServletRequestWrapper(new MyMultipartRequest(req, _destDir));
			} catch(IOException ex) {
				return new HttpServletRequestWrapper(req);
			}
		}
	}

}

