package org.enhydra.barracuda.contrib.dbroggisch.examples;


import java.util.*;
import javax.servlet.http.*;
import org.enhydra.barracuda.core.comp.*;
import org.enhydra.barracuda.core.forms.*;
import org.enhydra.barracuda.core.event.*;
import org.enhydra.barracuda.core.util.dom.DefaultDOMWriter;
import org.enhydra.barracuda.core.util.dom.DOMWriter;

import org.enhydra.barracuda.contrib.dbroggisch.page.*;
import org.enhydra.barracuda.contrib.dbroggisch.examples.events.*;
import org.enhydra.barracuda.contrib.dbroggisch.examples.forms.*;
import org.enhydra.barracuda.contrib.dbroggisch.examples.pages.*;
import org.enhydra.barracuda.contrib.dbroggisch.examples.xmlc.*;
import org.enhydra.barracuda.contrib.dbroggisch.repopulation.*;
import org.enhydra.barracuda.contrib.dbroggisch.display.*;
import org.apache.log4j.Logger;

import org.enhydra.barracuda.core.event.ClientSideRedirectException;

import java.io.*;
import java.util.*;
import org.enhydra.barracuda.core.event.helper.EventConnectorFactory;
import org.enhydra.barracuda.core.event.helper.EventForwardingFactory;

import org.enhydra.barracuda.core.helper.servlet.HttpServletRequestWrapper;

import org.enhydra.xml.xmlc.XMLCStdFactory;



public class ExampleGateway extends DefaultEventGateway {
    protected static org.apache.log4j.Logger logger = org.apache.log4j.Logger.getLogger(ExampleGateway.class.getName());

	// 	static {
	// 		try {
	// 			logger.debug("Initialization...");								
						
	// 			FilterFactory.addMapping(ExampleGateway.class.getResourceAsStream("/standard_filter_mapping.xml"));
	// 			FilterFactory.loadFilters(ExampleGateway.class.getResourceAsStream("/filter.xml"));
	// 		} catch(Exception ex) {
	// 							StringWriter sw = new StringWriter();
// 				ex.printStackTrace(new PrintWriter(sw));
// 				logger.("" + sw);

	// 		}
	// 	}


	public ExampleGateway() {
		specifyLocalEventInterests(new EventConnectorFactory(RepopulationHandler.class), Repopulation.class);
		specifyLocalEventInterests(new EventConnectorFactory(RepopulationHandler.class), RenderRepopulation.class);
		specifyLocalEventInterests(new EventConnectorFactory(FileUploadHandler.class), FileUpload.class);
		specifyLocalEventInterests(new EventConnectorFactory(FileUploadHandler.class), RenderFileUpload.class);
		specifyLocalEventInterests(new EventConnectorFactory(PrefixMappingHandler.class), PrefixMapping.class);
		specifyLocalEventInterests(new EventConnectorFactory(PrefixMappingHandler.class), PrefixMappingAddChild.class);
		specifyLocalEventInterests(new EventConnectorFactory(PrefixMappingHandler.class), RenderPrefixMapping.class);
		specifyLocalEventInterests(new EventConnectorFactory(NavigationBarHandler.class), NavigationBar.class);
		registerPages();
	}

	private void registerPages() {
		PageFactory.addPageEventMapping(Repopulation.class, RepopulationPage.class);
		PageFactory.addPageEventMapping(LoadPrefixMappingPage.class, PrefixmappingPage.class);
		PageFactory.addPageEventMapping(FileUpload.class, FileUploadPage.class);
		// Add the dummy handler for the load events
		specifyLocalEventInterests(new EventConnectorFactory(PageFactory.DummyHandler.class), LoadPrefixMappingPage.class);
	}


	public static class RepopulationHandler extends PageEventListener {
		public void handleControlEvent(ControlEventContext context, Page p)
			throws EventException,
				   javax.servlet.ServletException,
				   java.io.IOException
		{
			HttpServletRequest request = context.getRequest();
			ExampleFormMap cfm = new ExampleFormMap();
			RepopulationPage rPage = (RepopulationPage)p;

			rPage.setState(ExampleBasePage.REPOPULATION);
			// We put the form map into the page
			// so it can act as template model for
			// the rendering process.
			rPage.setRFM(cfm);

			// The request is only mapped and validated if a special hidden parameter is present.
			// I usually call it "visited". Be careful to assign a unique name to it, or you might
			// expirience strange errors when the application event flow is routed to a different event 
			// handling form maps.
			if(ExampleFormMap.MODEL_NAME.equals(request.getParameter("visited"))) {
				try {
					// This is all you have to do - mapping and validation.
					cfm.map(request).validate(true);
					
					// Print all values the elements have.
					if(logger.isDebugEnabled()) {
						Map els = cfm.getElements();
						for(Iterator it = els.entrySet().iterator(); it.hasNext();) {
							Map.Entry entry = (Map.Entry)it.next();
							String name = (String)entry.getKey();
							FormElement fel = (FormElement)entry.getValue();
							logger.debug("Element " + name + ":");
							Object val = fel.getVal();
							if(val != null) {
								logger.debug("Value class: " + val.getClass().getName());
								logger.debug("Value: " + val);
							} else {
								logger.debug("Has a null-value");
							}
						}
					}
				} catch(ValidationException ex) {
					
				}
			}
			context.getEvent().setHandled(true);
			//			context.getQueue().addEvent(new RenderRepopulation());
		}
	}


	public static class FileUploadHandler extends PageEventListener {

		public void handleControlEvent(ControlEventContext context, Page p)
			throws EventException,
				   javax.servlet.ServletException,
				   java.io.IOException
		{
			HttpServletRequest request = context.getRequest();
			List realNames = new ArrayList();
			FileUploadPage fuPage = (FileUploadPage)p;
			fuPage.setState(ExampleBasePage.FILEUPLOAD);
			if(DBRApplicationGateway.WRAPPER_INSTALLED && 
			   ((HttpServletRequestWrapper)request).getCoreRequest() instanceof MyMultipartRequest) {
				MyMultipartRequest mReq = (MyMultipartRequest)((HttpServletRequestWrapper)request).getCoreRequest();
				Enumeration fnames = mReq.getFileNames();

				while(fnames.hasMoreElements()) {
					realNames.add(mReq.getFilesystemName((String)fnames.nextElement()));
				}
			}
			fuPage.setNames(realNames);
			context.getEvent().setHandled(true);
		}
	}

	public static class PrefixMappingHandler extends PageEventListener {

		public void handleControlEvent(ControlEventContext context, Page p)
			throws EventException,
				   javax.servlet.ServletException,
				   java.io.IOException
		{
			HttpServletRequest request = context.getRequest();
			List maps = new ArrayList();
			ParentFormMap pfm = new ParentFormMap();
			PrefixmappingPage pmPage = (PrefixmappingPage)p;
			pmPage.setState(ExampleBasePage.PREFIXMAPPING);
			maps.add(pfm);

			if(ParentFormMap.MODEL_NAME.equals(request.getParameter("visited"))) {
				try {
					pfm.map(request).validate(true);
				} catch(ValidationException ex) {
					StringWriter sw = new StringWriter();
					ex.printStackTrace(new PrintWriter(sw));
					logger.debug("" + sw);
				}
				int cc = 0;
				cc = (pfm.getVal(ParentFormMap.CHILD_COUNT) != null ?
					  ((Integer)pfm.getVal(ParentFormMap.CHILD_COUNT)).intValue() : 0);
				if(context.getEvent() instanceof PrefixMappingAddChild) {
					cc++;
					pfm.getElement(ParentFormMap.CHILD_COUNT).setOrigVal("" + cc);
							  
				}
				for(int i = 0; i < cc; i++) {
					ChildFormMap cfm = new ChildFormMap();
					cfm.setPrefix("CFM" + i);
					maps.add(cfm);
					try {
						cfm.map(request).validate(true);
					} catch(ValidationException ex) {
						StringWriter sw = new StringWriter();
						ex.printStackTrace(new PrintWriter(sw));
						logger.debug("" + sw);
					}					
				}
			}
			pmPage.setMaps(maps);
			context.getEvent().setHandled(true);
		}

	}


	public static class NavigationBarHandler extends PageEventListener {

		public void handleControlEvent(ControlEventContext context, Page p)
			throws EventException,
				   javax.servlet.ServletException,
				   java.io.IOException
		{
			ExampleBasePage basePage = (ExampleBasePage)p;
			List menupoints = new ArrayList(3);
			BLink bl = null;
			ExampleBasePage.State state = basePage.getState();
			if(state == ExampleBasePage.REPOPULATION) {
				bl = new BLink("*Repopulation", new Repopulation());
				menupoints.add(bl);
				bl = new BLink("FileUpload", new FileUpload());
				menupoints.add(bl);
				bl = new BLink("PrefixMapping", new PrefixMapping());
				menupoints.add(bl);

			}
			if(state == ExampleBasePage.PREFIXMAPPING) {
				bl = new BLink("Repopulation", new Repopulation());
				menupoints.add(bl);
				bl = new BLink("FileUpload", new FileUpload());
				menupoints.add(bl);
				bl = new BLink("*PrefixMapping", new PrefixMapping());
				menupoints.add(bl);
				
			}
			if(state == ExampleBasePage.FILEUPLOAD) {
				bl = new BLink("Repopulation", new Repopulation());
				menupoints.add(bl);
				bl = new BLink("*FileUpload", new FileUpload());
				menupoints.add(bl);
				bl = new BLink("PrefixMapping", new PrefixMapping());
				menupoints.add(bl);
				
			}
			basePage.setMenuPoints(menupoints);
		}
	}

}

