package org.enhydra.barracuda.contrib.dbroggisch.examples.pages;

import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;
import java.util.Set;
import java.io.IOException;
import org.enhydra.barracuda.core.event.*;
import org.enhydra.barracuda.core.comp.*;
import org.enhydra.barracuda.contrib.dbroggisch.page.*;
import org.enhydra.barracuda.contrib.dbroggisch.examples.events.*;
import org.enhydra.barracuda.contrib.dbroggisch.display.*;
import org.w3c.dom.Document;
import javax.servlet.ServletException;
import org.enhydra.barracuda.contrib.dbroggisch.examples.xmlc.*;
import org.enhydra.xml.xmlc.XMLCStdFactory;

public class ExampleBasePage extends AbstractPage {

    public static class State {
        private State() {}
    }

   
	public static final String NAVIGATION_MODEL_NAME = "NavigationModel";

    public static final State REPOPULATION = new State();
    public static final State PREFIXMAPPING = new State();
    public static final State FILEUPLOAD = new State();
    private State _state = REPOPULATION;


	List _menupoints;

	public void setMenuPoints(List menupoints) {
		_menupoints = menupoints;
	}

	public void setState(State state) {
		_state = state;
	}

	public State getState() {
		return _state;
	}

    public ExampleBasePage() {
        List dEvents = new ArrayList();
        dEvents.add(new NavigationBar());		
		setDefaultEvents(dEvents);
    }

    public void handOver(ControlEventContext ctx, Page p){
		createDefaultModels(ctx);
    }


    public void render(BComponent root, ViewContext vec, Document pDoc) throws EventException, ServletException, IOException
    {
		NavigationHTML doc = (NavigationHTML)pDoc;
		BTemplate navComp = new BTemplate();
		navComp.setView(new DefaultTemplateView(doc.getElementNavigationHook()));
		if(_menupoints == null) 
			return;
		navComp.addModel(new IterativeListModel(NAVIGATION_MODEL_NAME, _menupoints) {
				public Object getItem(String key) {
					if("MENUPOINT".equals(key)) {
						return _current;
					}
					return "UNDEFINED";
				}
			});

		root.addChild(navComp);		
    }

	public Document getDocument() {
		return new XMLCStdFactory(null, null).create(NavigationHTML.class);
	}

}
