package org.enhydra.barracuda.contrib.dbroggisch.examples.pages;

import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;
import java.util.Set;
import java.io.IOException;
import org.enhydra.barracuda.core.event.*;
import org.enhydra.barracuda.core.comp.*;
import org.enhydra.barracuda.contrib.dbroggisch.page.*;
import org.enhydra.barracuda.contrib.dbroggisch.examples.events.*;
import org.enhydra.barracuda.contrib.dbroggisch.examples.forms.*;
import org.enhydra.barracuda.contrib.dbroggisch.display.*;
import org.enhydra.barracuda.contrib.dbroggisch.repopulation.*;
import org.w3c.dom.Document;
import javax.servlet.ServletException;
import org.enhydra.barracuda.contrib.dbroggisch.examples.xmlc.*;
import org.enhydra.xml.xmlc.XMLCStdFactory;

public class PrefixmappingPage extends ExampleBasePage {

	List _maps;

	public void setMaps(List maps) {
		_maps = maps;
	}

    public void render(BComponent root, ViewContext vec, Document pDoc) throws EventException, ServletException, IOException
    {
		super.render(root, vec, pDoc);
		Integer childCount = null;
		PrefixMappingHTML doc = (PrefixMappingHTML) pDoc;
		BTemplate mapComp = new BTemplate();
		mapComp.setView(new DefaultTemplateView(doc.getElementTestHook()));
		if(_maps.size() > 0) {
			// This is the parent form map
			RepopulationFormMap rfm = (RepopulationFormMap)_maps.remove(0);
			mapComp.addModel(rfm);
			childCount = (Integer)rfm.getVal(ParentFormMap.CHILD_COUNT);
			}
		IterativeListModel ilm = new IterativeListModel(ChildFormMap.MODEL_NAME, _maps) {
				public Object getItem(String key) {
					return ((RepopulationFormMap)_current).getItem(key);
				}
			};
		mapComp.addModel(ilm);
		HashMapModel hmm = new HashMapModel();
		hmm.setName("ControlModel");
		hmm.setItem("SUBMIT", new BAction(new PrefixMapping()));
		hmm.setItem("ADD", new BAction(new PrefixMappingAddChild()));
		mapComp.addModel(hmm);
		
		HashMapModel foo = new HashMapModel();
		foo.setName("FooModel");
		foo.setItem(ParentFormMap.CHILD_COUNT, new BText(
														 childCount == null ? "None" : 
														 childCount.intValue() == 0 ? "None" :
														 "" + childCount.intValue()));
		
		mapComp.addModel(foo);
		root.addChild(mapComp);
    }

	public Document getDocument() {
		return new XMLCStdFactory(null, null).create(PrefixMappingHTML.class);
	}

}
