package org.enhydra.barracuda.contrib.dbroggisch.examples.pages;

import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;
import java.util.Set;
import java.io.IOException;
import org.enhydra.barracuda.core.event.*;
import org.enhydra.barracuda.core.comp.*;
import org.enhydra.barracuda.contrib.dbroggisch.page.*;
import org.enhydra.barracuda.contrib.dbroggisch.examples.events.*;
import org.enhydra.barracuda.contrib.dbroggisch.examples.forms.*;
import org.enhydra.barracuda.contrib.dbroggisch.display.*;
import org.enhydra.barracuda.contrib.dbroggisch.repopulation.*;
import org.w3c.dom.Document;
import javax.servlet.ServletException;
import org.enhydra.barracuda.contrib.dbroggisch.examples.xmlc.*;
import org.enhydra.xml.xmlc.XMLCStdFactory;

public class RepopulationPage extends ExampleBasePage {

	RepopulationFormMap _rfm;

	public void setRFM(RepopulationFormMap rfm) {
		_rfm = rfm;
	}

    public void render(BComponent root, ViewContext vec, Document pDoc) throws EventException, ServletException, IOException
    {
		super.render(root, vec, pDoc);
		RepopulationHTML doc = (RepopulationHTML) pDoc;
		// Fetch the map that's supposed to act as template model.
		ExampleFormMap cfm = (ExampleFormMap)_rfm;
		BTemplate loginComp = new BTemplate();
		loginComp.setView(new DefaultTemplateView(doc.getElementTestHook()));

		// Add the map as model to the BTemplate
		loginComp.addModel(cfm);

		// It is possible that the map contains multiple choice elements represented by their respective model.
		// That happens when you use CheckBoxes or Radiobuttons instead of combo-boxes. 
		// For now, Barracuda lacks the possibility to add these automatically, so we have to do it.
		List cModels = cfm.getChildModels();
		for(Iterator it = cModels.iterator(); it.hasNext();) {
			loginComp.addModel((TemplateModel)it.next());
		}

		// A simple hashmap based model for the buttons.
		HashMapModel hmm = new HashMapModel();
		hmm.setName("ControlModel");
		hmm.setItem("SUBMIT", new BAction(new Repopulation()));
		loginComp.addModel(hmm);
		root.addChild(loginComp);
    }

	public Document getDocument() {
		return new XMLCStdFactory(null, null).create(RepopulationHTML.class);
	}

}
