/*
 * Generated by emacs.
 *
 * $Log: AbstractPage.java,v $
 * Revision 1.1  2002/08/01 00:09:07  deets
 * Added page stuff.
 *
 * Revision 1.4  2002/04/08 15:23:33  droggisch
 * Should work with the latest CVS+Iman's patches now.
 *
 * Revision 1.3  2002/02/06 14:46:58  tdaly
 * cleaned up the contentitempage a little bit
 *
 */ 

package org.enhydra.barracuda.contrib.dbroggisch.page;

import org.enhydra.barracuda.core.comp.*;
import org.enhydra.barracuda.core.event.BaseEvent;
import org.enhydra.barracuda.core.event.ControlEventContext;
import org.enhydra.barracuda.core.event.ViewEventContext;
import org.enhydra.barracuda.core.event.EventException;
import org.enhydra.barracuda.core.event.DispatchQueue;
import org.enhydra.barracuda.core.event.ViewEventContext;
import org.enhydra.barracuda.core.event.helper.DefaultViewHandler;

import java.io.IOException;
import java.util.List;
import java.util.Iterator;

import org.w3c.dom.Document;

import javax.servlet.ServletException;

import org.apache.log4j.Logger;

/**
 * Describe class <code>AbstractPage</code> here.
 *
 * @author <a href="mailto:deets@web.de">Diez B. Roggisch</a>
 * @version 1.0
 */
public abstract class AbstractPage extends DefaultViewHandler implements Page {

    final private static Logger logger = Logger.getLogger(AbstractPage.class.getName());

    List dEvents;

    /**
	 * Describe <code>setDefaultEvents</code> method here.
	 *
	 * @param events a <code>List</code> value
	 */
	public void setDefaultEvents(List events) {
	    dEvents = events;
    }

    /**
	 * Describe <code>createDefaultModels</code> method here.
	 *
	 * @param ctx a <code>ControlEventContext</code> value
	 */
	public void createDefaultModels(ControlEventContext ctx) {
        filterEvents(ctx, dEvents);
    }
    
	
    /**
	 * Overload this method to perform the actual process of
	 * rendering.
	 *
	 * @param root a <code>BComponent</code> value you have to add your BComponents to.
	 * @param vec a <code>ViewContext</code> value
	 * @param doc a <code>Document</code> value which is obtained by calling getDocument()
	 * @exception EventException if an error occurs
	 * @exception ServletException if an error occurs
	 * @exception IOException if an error occurs
	 */
	public abstract void render(BComponent root, ViewContext vec, Document doc) 
		throws EventException, ServletException, IOException;


	/**
	 * Return a Document instance. This is called once before the rendering takes place and
	 * should return a new instance.
	 *
	 * @return a <code>Document</code> value
	 */
	public abstract Document getDocument();



    // handleviewevent is functionality that we don't necessarily want to throw
    // away.. but the whole render/handleviewevent thing is confusing. so we hide it here.
    // overriding the render method gives the old behavior.
    /**
	 * Describe <code>handleViewEvent</code> method here.
	 *
	 * @param root a <code>BComponent</code> value
	 * @param ctx a <code>ViewContext</code> value
	 * @return a <code>Document</code> value
	 * @exception EventException if an error occurs
	 * @exception ServletException if an error occurs
	 * @exception IOException if an error occurs
	 */
	public Document handleViewEvent(BComponent root, ViewContext ctx) 
	                throws EventException, ServletException, IOException {
		Document doc = getDocument();
		if(logger.isDebugEnabled()) {
			logger.debug("Document " + doc.getClass() + " created.");
		}
	    render(root, ctx, doc);
		return doc;
    }

    /**
	 * Describe <code>render</code> method here.
	 *
	 * @param vec a <code>ViewEventContext</code> value
	 * @exception EventException if an error occurs
	 * @exception ServletException if an error occurs
	 * @exception IOException if an error occurs
	 */
	public void render(ViewEventContext vec)
                    throws EventException, ServletException, IOException {
        printPretty = false;
	    handleViewEvent(vec);
    }

    /**
	 * Describe <code>filterEvents</code> method here.
	 *
	 * @param ctx a <code>ControlEventContext</code> value
	 * @param defaultEvents a <code>List</code> value
	 */
	public static void filterEvents(ControlEventContext ctx, List defaultEvents) {
    	if(defaultEvents != null) {
    	    BaseEvent event = ctx.getEvent();
    	    
    	    if (logger.isDebugEnabled()) logger.debug("Removing Events " + event.getClass().getName());
    	    
    	    for (Iterator it = defaultEvents.iterator(); it.hasNext();) {
        		BaseEvent defEv = (BaseEvent)it.next();
        		if (defEv.equals(event)) {
        		    if (logger.isDebugEnabled()) logger.debug("Removing Event");
        		    it.remove();
        		}		   
    	    }
    	    
    	    DispatchQueue queue = ctx.getQueue();
    	    
    	    for (Iterator it = defaultEvents.iterator(); it.hasNext();) {
    		    queue.addEvent((BaseEvent)it.next());
    	    }	    
    	}
    }


}
