package org.enhydra.barracuda.contrib.dbroggisch.page;

import org.enhydra.barracuda.core.event.*;

import java.util.*;
import java.io.*;

import org.apache.log4j.Logger;

public class PageFactory {

    final private static Logger logger = Logger.getLogger(PageFactory.class.getName());
    static Map s_pageClasses = new HashMap();

    // ***************************************************************
    // register pages now in the ApplicationGateway
    // (e.g. artn.novartis.edetailing.ui.EdetailingApplicationGateway)
    // ***************************************************************

    public static void addPageEventMapping(Class event, Class page) {
	    s_pageClasses.put(event, page);
	    if (logger.isDebugEnabled()) logger.debug("Registered page " + page.getName() + " for event " + event.getName());
    }

    public static Page createPage(BaseEvent event) {
        try {
            if (logger.isDebugEnabled()) {
                logger.debug("Creating page for " + event.getClass().getName());
                logger.debug(s_pageClasses);
            }
	        Class pageClass = (Class)s_pageClasses.get(event.getClass());
	        if (pageClass == null) {
		        if (logger.isDebugEnabled()) logger.debug("Couldn't find page for event: " + event.getClass().getName());
		        return null;
	        } else {
		        return (Page)pageClass.newInstance();
	        }
        } 
        catch (InstantiationException ex) {
            StringWriter sw = new StringWriter();
    	    ex.printStackTrace(new PrintWriter(sw));
    	    logger.error(sw.toString());
        }
        catch (IllegalAccessException ex) {
            StringWriter sw = new StringWriter();
    	    ex.printStackTrace(new PrintWriter(sw));
    	    logger.error(sw.toString());
        }
        //TODO: Error handling
        return null;
    }

    public static Class getPageClass(BaseEvent event) {
    	if (logger.isDebugEnabled()) {
    	    logger.debug("Creating page for " + event.getClass().getName());
    	    logger.debug(s_pageClasses);
    	}
    	return (Class)s_pageClasses.get(event.getClass());
    }


	public static class DummyHandler extends PageEventListener {
		public void handleControlEvent(ControlEventContext context, Page p)
			throws EventException,
				   javax.servlet.ServletException,
				   java.io.IOException
		{
			context.getEvent().setHandled(true);
		}

	}

}
