package org.enhydra.barracuda.contrib.dbroggisch.page;

import org.enhydra.barracuda.core.event.helper.EventConnectorFactory;
import org.enhydra.barracuda.core.event.ClientSideRedirectException;
import org.enhydra.barracuda.core.event.ControlEventContext;
import org.enhydra.barracuda.core.event.ViewEventContext;
import org.enhydra.barracuda.core.event.DefaultBaseEventListener;
import org.enhydra.barracuda.core.event.BaseEventListener;
import org.enhydra.barracuda.core.event.DefaultEventGateway;
import org.enhydra.barracuda.core.event.ListenerFactory;
import org.enhydra.barracuda.core.event.DefaultListenerFactory;
import org.enhydra.barracuda.core.event.EventException;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletRequest;
import org.apache.log4j.Logger;
import org.enhydra.barracuda.core.event.*;


public class RenderPageHandler extends DefaultBaseEventListener {

    final private static Logger logger = Logger.getLogger(RenderPageHandler.class.getName());


	public static class PageEventDispatcherFactory implements DispatcherFactory {
		public EventDispatcher getInstance() {
			return new PageEventDispatcher();
		}
	}

	public static class PageEventDispatcher extends DefaultEventDispatcher {
		RenderPage _rpe = new RenderPage();

		public void dispatchEvent(EventBroker eb,
								  EventContext context)
			throws EventException {
			context.putState(DefaultEventDispatcher.DEFAULT_RESPONSE_EVENT, _rpe);
			super.dispatchEvent(eb, context);				
		}
	}

    public static class RenderPageEventGW extends DefaultEventGateway {

	    public RenderPageEventGW() {
	        specifyLocalEventInterests(new EventConnectorFactory(RenderPageHandler.class), RenderPage.class);
    	    this.logger.debug("specifyLocalEventInterests(new EventConnectorFactory(RenderPageHandler.class), RenderPage.class);");
	    }
    }

    public void handleViewEvent(ViewEventContext context) 
                                	    throws EventException,
                                	           javax.servlet.ServletException,
                                	           java.io.IOException {


    	HttpServletRequest req = context.getRequest();
    	HttpSession session = req.getSession(false);

    	Page page = null;
    	if (session!=null) {
    	    page = (Page)session.getAttribute("PAGE");
    	}

    	if (page == null) {
    	    page = (Page)context.getState("PAGE");
    	}

    	if (page != null) {
    	    page.render(context);
    	} else {
    	    this.logger.warn("No page in session, no in context, go back WelcomePage/Login.");
    	    //throw new ClientSideRedirectException(new DisplayWelcomePage());
    	    throw new ClientSideRedirectException("index.html");
    	}
    	context.getEvent().setHandled(true);
    }
}
