/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site (http://www.enhydra.org/).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id: BContainer.java,v 1.3 2001/09/25 19:05:28 cryd0221 Exp $
 */
package org.enhydra.barracuda.core.comp;

import java.util.*;

/**
 * This interface defines the characteristics of a container. It
 * provides the ability to create a hierarchy of containers
 * and to navigate that hierachy. Every container has a parent,
 * except for the root container, who's parent is null.
 */
public interface BContainer {

    public void setParent(BContainer iparent);
    public BContainer getParent();
    public void setName(String iname);
    public String getName();
    public void addChild(BContainer child);
    public BContainer getChild(int index);
    public BContainer removeChild(BContainer child);
    public BContainer removeChild(int index);
    public void removeAll();
    public boolean hasChildren();
    public List getChildren();
    public void invalidate();
    public void validate();

}