/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site (http://www.enhydra.org/).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id: TemplateView.java,v 1.4 2001/09/25 19:05:28 cryd0221 Exp $
 */
package org.enhydra.barracuda.core.comp;

import java.util.*;
import org.w3c.dom.*;

import org.enhydra.barracuda.core.util.data.*;

/**
 * This interface defines a View for Table components to 
 * render themselves in. Similar to the java.awt.Graphics 
 * object in AWT and Swing.
 */
public interface TemplateView extends View {
    public Node getMasterTemplate();
    public void setDirIDMap(StateMap idMap);
    public StateMap getDirIDMap();
    public TemplateDirective lookupDir(String dirStr);
    public List lookupDirsByID(String idStr);
    public void setIDAttrName(String idAttrName);
    public String getIDAttrName();
    public void setDirAttrName(String dirAttrName);
    public String getDirAttrName();
}