/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site (http://www.enhydra.org/).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 *
 * $Id: ClientSideRedirectException.java,v 1.5 2001/09/25 19:05:29 cryd0221 Exp $
 */
package org.enhydra.barracuda.core.event;


/**
 * This class defines a ClientSideRedirectException...throwing this will
 * cause the ApplicationGateway to redirect the browser to the
 * new Event.
 */
public class ClientSideRedirectException extends EventException {

    //private vars
    private String url = null;

    /**
     * The public contructor for ClientSideRedirectException
     *
     * @param newEvent - the newEvent the client browser
     *        should be redirected to
     */
    public ClientSideRedirectException (BaseEvent newEvent) {
        // RTL20010719 url = newEvent.getEventID()+newEvent.getEventExtension();
        url = newEvent.getEventIDWithExtension();
    }

    /**
     * The public contructor for ClientSideRedirectException
     *
     * @param url - the URL the client browser should be
     *         redirected to
     */
    public ClientSideRedirectException (String iurl) {
        url = iurl;
    }

    /**
     * Get the new event that triggered this interrupt
     */
    public String getRedirectURL() {
        return url;
    }
}
