/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site (http://www.enhydra.org/).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id: AbstractBlockIterator.java,v 1.2 2002/05/29 06:17:35 JacobK Exp $
 */
package org.enhydra.barracuda.core.event.helper;

import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

import org.w3c.dom.*;
import org.w3c.dom.html.*;
import org.enhydra.xml.xmlc.*;

import org.enhydra.barracuda.core.comp.*;
import org.enhydra.barracuda.core.util.dom.*;
import org.enhydra.barracuda.core.event.*;
import org.enhydra.barracuda.core.helper.servlet.*;
import org.enhydra.barracuda.core.util.*;
import org.enhydra.barracuda.core.util.exceptions.*;
import org.enhydra.barracuda.core.view.*;
import org.enhydra.barracuda.core.util.http.*;
import org.apache.log4j.*;

/**
 * This class provides the abstract implementation of a BlockIterator. Basically,
 * it will
 */
public abstract class AbstractBlockIterator implements BlockIterator {
//    protected Node templateNode = null;
    protected BTemplate templateComp = null;
  
/*    
    public void setTemplateNode(Node inode) {
        templateNode = inode;
    }

    public Node getTemplateNode() {
        return templateNode;
    }
*/
    public void updateModelInTemplate(TemplateModel model) {
        if (templateComp!=null) templateComp.addModel(model);
    }
    
    public Node next(ViewContext vc, Node templateNode) throws RenderException {
        try {
            //allow the developer to load the next record
            if (!loadNext()) return null;            
    
            //create our root component
            BComponent broot = new BComponent();
            broot.setName("Root");

            //create a template component and bind it to the views
            templateComp = new BTemplate();
            Object o = getTemplateModels();
            if (o instanceof TemplateModel) templateComp.addModel((TemplateModel) o);
            else if (o instanceof List) templateComp.addModels((List) o);
            else throw new RuntimeException("Fatal err: Model must return either TemplateModel or List");
            templateComp.setView(new DefaultTemplateView(templateNode));
            broot.addChild(templateComp);
        
            //now init the component
            broot.initCycle();

            //now render the component
            broot.render(vc);

            //now destroy the component
            broot.destroyCycle();
            templateComp = null;
        
            //now return the rendered node
            return templateNode;
        } finally {
        
        }
    }

    public abstract boolean loadNext();

    public abstract Object getTemplateModels();
}
