package org.enhydra.barracuda.examples.xmlc;

import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

import org.w3c.dom.*;
import org.w3c.dom.html.*;
import org.enhydra.xml.xmlc.*;

import org.enhydra.barracuda.core.comp.*;
import org.enhydra.barracuda.core.comp.helper.*;
import org.enhydra.barracuda.core.util.dom.*;
import org.enhydra.barracuda.core.event.*;
import org.enhydra.barracuda.core.util.dom.*;
import org.enhydra.barracuda.core.view.*;
import org.enhydra.barracuda.examples.xmlc.data.*;

/**
 * Test our ability to detect client side Javascript being 
 * enabled.
 */
public class CompEx8 extends BTemplateGateway {

    

    //-------------------- BTemplateGateway ----------------------
    /**
     * Return an instance of the template model
     */
    public TemplateModel getTemplateModel() {
        return new LocalTemplateModel();
    }
    
    /**
     * Return an instance of the template class (must implement Document)
     */
    public Class getTemplateClass() {
        return CompEx8HTML.class;
    }
    
    public DOMWriter getDOMWriter() {
        return new DefaultDOMWriter(true);
    }

    //--------------- TemplateModel --------------------------
    /**
     * LocalTemplateModel
     */
    class LocalTemplateModel extends AbstractTemplateModel {
    
        //register the model by name
        public String getName() {return "Ex8";}
        
        //provide items by key
        public Object getItem(String key) {
            ViewContext vc = getViewContext();
            ViewCapabilities vcap = vc.getViewCapabilities();
            if (key.equals("Link1")) {
                return new BLink("A sample link", "/Barracuda/CompTest8");
            } else if (key.equals("Form1")) {
                return new BAction("/Barracuda/CompTest8");
            } else {
                return super.getItem(key);
            }
        }
    }
}
